//-----------------------------------------------------------------------------
// blend.c : uh
// Copyright (c) 2005-2008  N099
//-----------------------------------------------------------------------------
#include <windows.h>

#include "filter.h"
#include "blend.h"

// gpW
static const u128i_i32 xc_4k = { 4096, 4096, 4096, 4096 };
static const u128i_i32 xc_2k = { 2047, 2047, 2047, 2047 };

//̗ʂɂăuh
// mv0o mv1͗pȂ
NOA void blend_image(PIXEL_YC * restrict dst, const PIXEL_YC * restrict src,
                     const short * restrict mv0, const short * restrict mv1, int w)
{
    int i;
    int y,cr,cb,c0,c1;
    
    for(i=0; i<w; ++i){
        c0 = *mv0++;
        c1 = 4096 - c0;
        
        y  = c0 * dst->y  + c1 * src->y  + 2047;
        cb = c0 * dst->cb + c1 * src->cb + 2047;
        cr = c0 * dst->cr + c1 * src->cr + 2047;
        
        dst->y  = (short)(y  >> 12);
        dst->cb = (short)(cb >> 12);
        dst->cr = (short)(cr >> 12);
        
        dst++;
        src++;
    }
}

//̗ʂɂăuh
// 2̌oʂ̂ق𗘗p
NOA void blend_image_min(PIXEL_YC * restrict dst, const PIXEL_YC * restrict src,
                         const short * restrict mv0, const short * restrict mv1, int w)
{
    int i;
    int y,cr,cb,c0,c1;
    
    for(i=0; i<w; ++i){
        c0 = *mv0++;
        c1 = *mv1++;
        c0 = c0 < c1 ? c0 : c1;
        c1 = 4096 - c0;
        
        y  = c0 * dst->y  + c1 * src->y  + 2047;
        cb = c0 * dst->cb + c1 * src->cb + 2047;
        cr = c0 * dst->cr + c1 * src->cr + 2047;
        
        dst->y  = (short)(y  >> 12);
        dst->cb = (short)(cb >> 12);
        dst->cr = (short)(cr >> 12);
        
        dst++;
        src++;
    }
}

//̗ʂɂăuh
// 2̌oʂ̂傫ق𗘗p
NOA void blend_image_max(PIXEL_YC * restrict dst, const PIXEL_YC * restrict src,
                         const short * restrict mv0, const short * restrict mv1, int w)
{
    int i;
    int y,cr,cb,c0,c1;
    
    for(i=0; i<w; ++i){
        c0 = *mv0++;
        c1 = *mv1++;
        c0 = c0 > c1 ? c0 : c1;
        c1 = 4096 - c0;
        
        y  = c0 * dst->y  + c1 * src->y  + 2047;
        cb = c0 * dst->cb + c1 * src->cb + 2047;
        cr = c0 * dst->cr + c1 * src->cr + 2047;
        
        dst->y  = (short)(y  >> 12);
        dst->cb = (short)(cb >> 12);
        dst->cr = (short)(cr >> 12);
        
        dst++;
        src++;
    }
}


//̗ʂɂăuh SSE2
// mv0o mv1͗pȂ
NOA void blend_image_sse2(PIXEL_YC * restrict dst, const PIXEL_YC * restrict src,
                          const short * restrict mv0, const short * restrict mv1, int w)
{
    int i;
    __m128i xm0,xm1,xd0,xs0,xc0,xc1,xc2;
    
    xc0 = _mm_loadl_epi64((p_m128c)mv0);
    mv0 += 4;
    
    //4pixel
    for(i=0; i<w; i+=4){
        xc0 = _mm_unpacklo_epi16(xc0, _mm_setzero_si128()); //xc0 (c3,c2,c1,c0)
        xc1 = _mm_sub_epi32(xc_4k.x, xc0); //xc1 (4k-c3,4k-c2,4k-c1,4k-c0)
        
        xc0 = _mm_slli_epi32(xc0, 16);
        xc0 = _mm_or_si128(xc0, xc1); //xc0 (c3,4k-c3,c2,4k-c2,c1,4k-c1,c0,4k-c0)

        xc2 = _mm_shuffle_epi32(xc0, 0xFE); //3,3,3,2:11111110
        xc1 = _mm_shuffle_epi32(xc0, 0xA5); //2,2,1,1:10100101
        xc0 = _mm_shuffle_epi32(xc0, 0x40); //1,0,0,0:01000000
        
        //load:0,1
        xd0 = _mm_loadu_si128((p_m128r)dst); //xd0 (Cbd2, Yd2, Crd1, Cbd1, Yd1, Crd0, Cbd0, Yd0)
        xs0 = _mm_loadu_si128((p_m128c)src); //xs0 (Cbs2, Ys2, Crs1, Cbs1, Ys1, Crs0, Cbs0, Ys0)
                
        xm0 = _mm_unpackhi_epi16(xs0, xd0); //xm0 (Cbd2, Cbs2,  Yd2,  Ys2, Crd1, Crs1, Cbd1, Cbs1)
        xm1 = _mm_unpacklo_epi16(xs0, xd0); //xm1 ( Yd1,  Ys1, Crd0, Crs0, Cbd0, Cbs0,  Yd0,  Ys0)
        
        //load:2
        xd0 = _mm_loadl_epi64((p_m128r)dst + 1); //xd0 (0,, Crd3, Cbd3, Yd3, Crd2)
        xs0 = _mm_loadl_epi64((p_m128c)src + 1); //xs0 (0,, Crs3, Cbs3, Ys3, Crs2)
        
        xm0 = _mm_madd_epi16(xm0, xc1); //xm0 (Cb2,  Y2, Cr1, Cb1)
        xm1 = _mm_madd_epi16(xm1, xc0); //xm1 ( Y1, Cr0, Cb0,  Y0)
        
        xc0 = _mm_loadl_epi64((p_m128c)mv0); //ǂ
        
        xm0 = _mm_add_epi32(xm0, xc_2k.x);
        xm1 = _mm_add_epi32(xm1, xc_2k.x);
        
        xm0 = _mm_srai_epi32(xm0, 12);
        xm1 = _mm_srai_epi32(xm1, 12);
        
        //store:0,1
        _mm_storeu_si128((p_m128r)dst, _mm_packs_epi32(xm1, xm0));

        xm1 = _mm_unpacklo_epi16(xs0, xd0); //xm1 (Crd3, Crs3, Cbd3, Cbs3, Yd3, Ys3, Crd2, Crs2)
        xm1 = _mm_madd_epi16(xm1, xc2); //mm1 (Cr3, Cb3, Y3, Cr2)
        xm1 = _mm_add_epi32(xm1, xc_2k.x);
        xm1 = _mm_srai_epi32(xm1, 12);
        
        //store:2
        _mm_storel_epi64((p_m128r)dst + 1, _mm_packs_epi32(xm1, xm1));
        
        mv0 += 4;
        dst += 4;
        src += 4;
    }
}

//̗ʂɂăuh SSE2
// 2̌oʂ̂ق𗘗p
NOA void blend_image_min_sse2(PIXEL_YC * restrict dst, const PIXEL_YC * restrict src,
                              const short * restrict mv0, const short * restrict mv1, int w)
{
    int i;
    __m128i xm0,xm1,xd0,xs0,xc0,xc1,xc2;
    
    xc0 = _mm_loadl_epi64((p_m128c)mv0);
    xc1 = _mm_loadl_epi64((p_m128c)mv1);
    xc0 = _mm_min_epi16(xc0, xc1);
    mv0 += 4;
    mv1 += 4;
    
    //4pixel
    for(i=0; i<w; i+=4){
        xc0 = _mm_unpacklo_epi16(xc0, _mm_setzero_si128()); //xc0 (c3,c2,c1,c0)
        xc1 = _mm_sub_epi32(xc_4k.x, xc0); //xc1 (4k-c3,4k-c2,4k-c1,4k-c0)
        
        xc0 = _mm_slli_epi32(xc0, 16);
        xc0 = _mm_or_si128(xc0, xc1); //xc0 (c3,4k-c3,c2,4k-c2,c1,4k-c1,c0,4k-c0)

        xc2 = _mm_shuffle_epi32(xc0, 0xFE); //3,3,3,2:11111110
        xc1 = _mm_shuffle_epi32(xc0, 0xA5); //2,2,1,1:10100101
        xc0 = _mm_shuffle_epi32(xc0, 0x40); //1,0,0,0:01000000
        
        //load:0,1
        xd0 = _mm_loadu_si128((p_m128r)dst); //xd0 (Cbd2, Yd2, Crd1, Cbd1, Yd1, Crd0, Cbd0, Yd0)
        xs0 = _mm_loadu_si128((p_m128c)src); //xs0 (Cbs2, Ys2, Crs1, Cbs1, Ys1, Crs0, Cbs0, Ys0)
                
        xm0 = _mm_unpackhi_epi16(xs0, xd0); //xm0 (Cbd2, Cbs2,  Yd2,  Ys2, Crd1, Crs1, Cbd1, Cbs1)
        xm1 = _mm_unpacklo_epi16(xs0, xd0); //xm1 ( Yd1,  Ys1, Crd0, Crs0, Cbd0, Cbs0,  Yd0,  Ys0)
        
        //load:2
        xd0 = _mm_loadl_epi64((p_m128r)dst + 1); //xd0 (0,, Crd3, Cbd3, Yd3, Crd2)
        xs0 = _mm_loadl_epi64((p_m128c)src + 1); //xs0 (0,, Crs3, Cbs3, Ys3, Crs2)
        
        xm0 = _mm_madd_epi16(xm0, xc1); //xm0 (Cb2,  Y2, Cr1, Cb1)
        xm1 = _mm_madd_epi16(xm1, xc0); //xm1 ( Y1, Cr0, Cb0,  Y0)
        
        //ǂ
        xc0 = _mm_loadl_epi64((p_m128c)mv0);
        xc1 = _mm_loadl_epi64((p_m128c)mv1);
        xc0 = _mm_min_epi16(xc0, xc1);
        
        xm0 = _mm_add_epi32(xm0, xc_2k.x);
        xm1 = _mm_add_epi32(xm1, xc_2k.x);
        
        xm0 = _mm_srai_epi32(xm0, 12);
        xm1 = _mm_srai_epi32(xm1, 12);
        
        //store:0,1
        _mm_storeu_si128((p_m128r)dst, _mm_packs_epi32(xm1, xm0));

        xm1 = _mm_unpacklo_epi16(xs0, xd0); //xm1 (Crd3, Crs3, Cbd3, Cbs3, Yd3, Ys3, Crd2, Crs2)
        xm1 = _mm_madd_epi16(xm1, xc2); //mm1 (Cr3, Cb3, Y3, Cr2)
        xm1 = _mm_add_epi32(xm1, xc_2k.x);
        xm1 = _mm_srai_epi32(xm1, 12);
        
        //store:2
        _mm_storel_epi64((p_m128r)dst + 1, _mm_packs_epi32(xm1, xm1));
        
        mv0 += 4;
        mv1 += 4;
        dst += 4;
        src += 4;
    }
}

//̗ʂɂăuh SSE2
// 2̌oʂ̂傫ق𗘗p
NOA void blend_image_max_sse2(PIXEL_YC * restrict dst, const PIXEL_YC * restrict src,
                              const short * restrict mv0, const short * restrict mv1, int w)
{
    int i;
    __m128i xm0,xm1,xd0,xs0,xc0,xc1,xc2;
    
    xc0 = _mm_loadl_epi64((p_m128c)mv0);
    xc1 = _mm_loadl_epi64((p_m128c)mv1);
    xc0 = _mm_max_epi16(xc0, xc1);
    mv0 += 4;
    mv1 += 4;
    
    //4pixel
    for(i=0; i<w; i+=4){
        xc0 = _mm_unpacklo_epi16(xc0, _mm_setzero_si128()); //xc0 (c3,c2,c1,c0)
        xc1 = _mm_sub_epi32(xc_4k.x, xc0); //xc1 (4k-c3,4k-c2,4k-c1,4k-c0)
        
        xc0 = _mm_slli_epi32(xc0, 16);
        xc0 = _mm_or_si128(xc0, xc1); //xc0 (c3,4k-c3,c2,4k-c2,c1,4k-c1,c0,4k-c0)

        xc2 = _mm_shuffle_epi32(xc0, 0xFE); //3,3,3,2:11111110
        xc1 = _mm_shuffle_epi32(xc0, 0xA5); //2,2,1,1:10100101
        xc0 = _mm_shuffle_epi32(xc0, 0x40); //1,0,0,0:01000000
        
        //load:0,1
        xd0 = _mm_loadu_si128((p_m128r)dst); //xd0 (Cbd2, Yd2, Crd1, Cbd1, Yd1, Crd0, Cbd0, Yd0)
        xs0 = _mm_loadu_si128((p_m128c)src); //xs0 (Cbs2, Ys2, Crs1, Cbs1, Ys1, Crs0, Cbs0, Ys0)
                
        xm0 = _mm_unpackhi_epi16(xs0, xd0); //xm0 (Cbd2, Cbs2,  Yd2,  Ys2, Crd1, Crs1, Cbd1, Cbs1)
        xm1 = _mm_unpacklo_epi16(xs0, xd0); //xm1 ( Yd1,  Ys1, Crd0, Crs0, Cbd0, Cbs0,  Yd0,  Ys0)
        
        //load:2
        xd0 = _mm_loadl_epi64((p_m128r)dst + 1); //xd0 (0,, Crd3, Cbd3, Yd3, Crd2)
        xs0 = _mm_loadl_epi64((p_m128c)src + 1); //xs0 (0,, Crs3, Cbs3, Ys3, Crs2)
        
        xm0 = _mm_madd_epi16(xm0, xc1); //xm0 (Cb2,  Y2, Cr1, Cb1)
        xm1 = _mm_madd_epi16(xm1, xc0); //xm1 ( Y1, Cr0, Cb0,  Y0)
        
        //ǂ
        xc0 = _mm_loadl_epi64((p_m128c)mv0);
        xc1 = _mm_loadl_epi64((p_m128c)mv1);
        xc0 = _mm_max_epi16(xc0, xc1);
        
        xm0 = _mm_add_epi32(xm0, xc_2k.x);
        xm1 = _mm_add_epi32(xm1, xc_2k.x);
        
        xm0 = _mm_srai_epi32(xm0, 12);
        xm1 = _mm_srai_epi32(xm1, 12);
        
        //store:0,1
        _mm_storeu_si128((p_m128r)dst, _mm_packs_epi32(xm1, xm0));

        xm1 = _mm_unpacklo_epi16(xs0, xd0); //xm1 (Crd3, Crs3, Cbd3, Cbs3, Yd3, Ys3, Crd2, Crs2)
        xm1 = _mm_madd_epi16(xm1, xc2); //mm1 (Cr3, Cb3, Y3, Cr2)
        xm1 = _mm_add_epi32(xm1, xc_2k.x);
        xm1 = _mm_srai_epi32(xm1, 12);
        
        //store:2
        _mm_storel_epi64((p_m128r)dst + 1, _mm_packs_epi32(xm1, xm1));
        
        mv0 += 4;
        mv1 += 4;
        dst += 4;
        src += 4;
    }
}


//\
NOA void disp_motion(PIXEL_YC * restrict dst,
                     const short * restrict mv0, const short * restrict mv1,
                     int mode, int h, int w, int s)
{
    int i,j,k=1;
    int m0,m1;
    const int wc[4][2] =
        { { -2231, 3435 }, { 3435, 2231 }, { -3435, 2231 }, { -3435, -2231 } };
    
    if(mode == 0){
        // Ot[̂
        for(i=0; i<h; ++i){
            for(j=0; j<w; ++j){
                m0 = *(mv0 + j);
                
                (dst + j)->cb = (short)((m0 * wc[k][0]) >> 13);
                (dst + j)->cr = (short)((m0 * wc[k][1]) >> 13);
            }
            dst += s;
            mv0 += s;
        }
    }else if(mode == 2){
        //Ot[ ől
        for(i=0; i<h; ++i){
            for(j=0; j<w; ++j){
                m0 = *(mv0 + j);
                m1 = *(mv1 + j);
                m0 = m0 > m1 ? m0 : m1;
                
                (dst + j)->cb = (short)((m0 * wc[k][0]) >> 13);
                (dst + j)->cr = (short)((m0 * wc[k][1]) >> 13);
            }
            dst += s;
            mv0 += s;
            mv1 += s;
        }
    }else if(mode == 1){
        //Ot[ ŏl
        for(i=0; i<h; ++i){
            for(j=0; j<w; ++j){
                m0 = *(mv0 + j);
                m1 = *(mv1 + j);
                m0 = m0 < m1 ? m0 : m1;
                
                (dst + j)->cb = (short)((m0 * wc[k][0]) >> 13);
                (dst + j)->cr = (short)((m0 * wc[k][1]) >> 13);
            }
            dst += s;
            mv0 += s;
            mv1 += s;
        }
    }
}

